
#define REAL_SHIPS_QUANTITY 900

object	RealShips[REAL_SHIPS_QUANTITY];

ref GetRealShip(int iType) 
{ 
	if(iType >= REAL_SHIPS_QUANTITY)
	{
		trace ("--- Wrong Ship Index. iType is " + iType);
		Log_TestInfo("--- Wrong Ship Index. iType is " + iType);
		return &ShipsTypes[SHIP_TYPES_QUANTITY + 1]; //  
	}
	return &RealShips[iType]; 
}

// isLock - ,   (26.05.06 boal)
//   isLock (04.07.06)     (   )
//  1 - ,  , 0 -   -  .
int GenerateShip(int iBaseType, bool isLock)
{
	int iShip = CreateBaseShip(iBaseType);

	if (iShip == -1)
	{
		return SHIP_NOTUSED;
	}
	
	ref rRealShip = GetRealShip(iShip);
	ref rBaseShip = GetShipByType(sti(rRealShip.BaseType));
    // boal 26/05/06 
    rRealShip.ship.upgrades.hull  = 1 + rand(2);  //  
	rRealShip.ship.upgrades.sails = 1 + rand(2);  //   
	
	if (!CheckAttribute(rRealShip, "isFort"))
	{
	    int iCaliber = sti(rRealShip.MaxCaliber);
	    if (sti(rRealShip.Class) != 7)
	    {  //      16
		    switch(iCaliber)
		    {
				case 4:
					iCaliber = 0;
				break;
				case 6:
					iCaliber = 1;
				break;
				case 8:
					iCaliber = 2;
				break;
				case 10:
					iCaliber = 3;
				break;
				case 12:
					iCaliber = 4;
				break;
				case 14:
					iCaliber = 5;
				break;
				case 16:
					iCaliber = 6;
				break;
				case 18:
					iCaliber = 7;
				break;
				case 20:
					iCaliber = 8;
				break;
				case 22:
					iCaliber = 9;
				break;
				case 24:
					iCaliber = 10;
				break;
				case 26:
					iCaliber = 11;
				break;
				case 32:
					iCaliber = 12;
				break;
				case 35:
					iCaliber = 13;
				break;
                                case 36:
					iCaliber = 14;
				break;
				case 42:
					iCaliber = 15;
				break;
                                case 48:
					iCaliber = 16;
				break;
				case 68:
					iCaliber = 17;
				break;
                                case 92:
					iCaliber = 18;
				break;
		    }
		    iCaliber = iCaliber + rand(2) - 1;
		    if (iCaliber < 0) iCaliber = 0;
		    if (rRealShip.BaseName == "Manowar")
		    {
		    	if (iCaliber > 15) iCaliber = 15;
		    }
		    else
		    {
		    	if (iCaliber > 16) iCaliber = 16;
		    }
		    switch(iCaliber)
		    {
				case 0:
					iCaliber = 4;
				break;
				case 1:
					iCaliber = 6;
				break;
                                case 2:
					iCaliber = 8;
				break;
				case 3:
					iCaliber = 10;
				break;
				case 4:
					iCaliber = 12;
				break;
				case 5:
					iCaliber = 14;
				break;
				case 6:
					iCaliber = 16;
				break;
				case 7:
					iCaliber = 18;
				break;
				case 8:
					iCaliber = 20;
				break;
				case 9:
					iCaliber = 22;
				break;
				case 10:
					iCaliber = 24;
				break;
				case 11:
					iCaliber = 26;
				break;
				case 12:
					iCaliber = 32;
				break;
				case 13:
					iCaliber = 34;
				break;
                                case 14:
					iCaliber = 36;
				break;
				case 15:
					iCaliber = 42;
				break;
                                case 16:
					iCaliber = 48;
				break;
				case 17:
					iCaliber = 68;
				break;
                                case 18:
					iCaliber = 92;
				break;
		    }
		    rRealShip.MaxCaliber = iCaliber;
	    }
	    rRealShip.SpeedRate	       = stf(rRealShip.SpeedRate) + frandSmall(stf(rRealShip.SpeedRate) / 5.0) - stf(rRealShip.SpeedRate) / 10.0;
	    rRealShip.TurnRate         = stf(rRealShip.TurnRate) + frandSmall(stf(rRealShip.TurnRate) / 5.0) - stf(rRealShip.TurnRate) / 10.0;
	    //rRealShip.Price            = sti(rRealShip.Price) + rand(makeint(sti(rRealShip.Price)/2)) - makeint(sti(rRealShip.Price)/4);
	    rRealShip.HP               = sti(rRealShip.HP) + rand(makeint(sti(rRealShip.HP)/5)) - makeint(sti(rRealShip.HP)/10);
	    rRealShip.WindAgainstSpeed = stf(rRealShip.WindAgainstSpeed) + frandSmall(stf(rRealShip.WindAgainstSpeed)/5.0) - stf(rRealShip.WindAgainstSpeed)/10.0;
	}
    rRealShip.Capacity        = sti(rRealShip.Capacity) + rand(makeint(sti(rRealShip.Capacity)/4)) - makeint(sti(rRealShip.Capacity)/8);
    rRealShip.OptCrew         = makeint(sti(rRealShip.OptCrew) + rand(makeint(sti(rRealShip.OptCrew)/3)) - makeint(sti(rRealShip.OptCrew)/6));
    rRealShip.MaxCrew         = makeint(sti(rRealShip.OptCrew) * 1.25 + 0.5);  // 25% 
    rRealShip.MinCrew         = makeint(sti(rRealShip.MinCrew) + rand(makeint(sti(rRealShip.MinCrew)/3)) - makeint(sti(rRealShip.MinCrew)/6));

	rRealShip.Weight		  = sti(rRealShip.Weight) + rand(sti(rRealShip.Weight)/20) - rand(sti(rRealShip.Weight)/20);
	
	// to_do del -->
	rRealShip.BoardingCrew    = 0;
	rRealShip.GunnerCrew      = 0;
	rRealShip.CannonerCrew    = 0;
	rRealShip.SailorCrew      = sti(rRealShip.OptCrew);
    // to_do del <--
    
	int iDiffWeight			= sti(rRealShip.Weight) - sti(rBaseShip.Weight);
	int iDiffCapacity		= sti(rRealShip.Capacity) - sti(rBaseShip.Capacity);
	int iDiffMaxCrew		= sti(rRealShip.MaxCrew) - sti(rBaseShip.MaxCrew);
	int iDiffMinCrew		= sti(rRealShip.MinCrew) - sti(rBaseShip.MinCrew);
	float fDiffSpeedRate	= stf(rRealShip.SpeedRate) - stf(rBaseShip.SpeedRate);
	int iDiffTurnRate		= sti(rRealShip.TurnRate) - sti(rBaseShip.TurnRate);
	int iDiffHP	    		= sti(rRealShip.HP) - sti(rBaseShip.HP);

	rRealShip.Price	= (iDiffWeight + iDiffCapacity + iDiffMaxCrew*2 + iDiffMinCrew + fDiffSpeedRate*2 + iDiffTurnRate*2 + iDiffHP)*5 + sti(rRealShip.Price);

	if (sti(rRealShip.Price) <= 0) rRealShip.Price = 100;
	
	rRealShip.Stolen = isLock;  // 

	return iShip;
}

int CreateBaseShip(int iBaseType)
{
	int iShip = FindFirstEmptyShip();

	if(iShip == -1)
	{
        trace("Can not find empty ship slot");
		return SHIP_NOTUSED;
	}

	ref rBaseShip = GetShipByType(iBaseType);
	ref rRealShip = GetRealShip(iShip);
	DeleteAttribute(rRealShip, "");
	CopyAttributes(rRealShip, rBaseShip);
    rRealShip.index = iShip;
    rRealShip.BaseType = iBaseType;
    if (!CheckAttribute(rRealShip, "ship.upgrades.hull")) //    ,   ,  
    {
    	rRealShip.ship.upgrades.hull = 1;  //  
    }
	rRealShip.ship.upgrades.sails = 1;
	
    rRealShip.BaseName = rRealShip.name; //   ,    ''
	if (rRealShip.name != "Fort" && rRealShip.name != "Boat") //    :(
	{
		rRealShip.name = rRealShip.name + "1"; //   ,  !!!!!!!!!!!!!!
		//  -       1,   
	}
    rRealShip.Stolen = 0;  //  - 
    
	if (iArcadeSails == 0) //     
	{
	    rRealShip.InertiaAccelerationY = stf(rRealShip.InertiaAccelerationY) / 2.0;
	}
    
	return iShip;
}
//    
int GenerateStoreShip(int iBaseType)
{
	int iShip = GenerateShip(iBaseType, 0); //  

	if (iShip == -1)
	{
		return SHIP_NOTUSED;
	}
	
	ref rRealShip = GetRealShip(iShip);
    rRealShip.StoreShip = true;  //   ,   
    
	return iShip;	
}
//   26.05.06 boal
// :   ,   -,   
void EmptyAllFantomShips()
{
	int  i;
	ref  chr;
	//   -  ,    .      ,  ,   
	for (i = 0; i < REAL_SHIPS_QUANTITY; i++)
	{
        DeleteAttribute(&RealShips[i], "lock");
	}
	//  ,        MAX_CHARACTERS
	RealShips[sti(Characters[BOAT_CHARACTER].ship.type)].lock = true;
	//  -
	for (i = 0; i < MAX_CHARACTERS; i++)
	{
        chr = &Characters[i];
        if (CheckAttribute(chr, "ship.type") && chr.ship.type != SHIP_NOTUSED)
        {
            RealShips[sti(chr.ship.type)].lock = true;
        }
        //   
		if (CheckAttribute(chr, "shipyard"))
		{
		    FreeShipFromShipyard(chr);
		}
	}
	for (i = FANTOM_CHARACTERS; i < TOTAL_CHARACTERS; i++) //   
	{
        chr = &Characters[i];
        if (CheckAttribute(chr, "ship.type") && chr.ship.type != SHIP_NOTUSED)
        {
            RealShips[sti(chr.ship.type)].lock = true;
        }
	}
	//   
	for (i = 0; i < REAL_SHIPS_QUANTITY; i++)
	{
        if (!CheckAttribute(&RealShips[i], "lock") && !CheckAttribute(&RealShips[i], "StoreShip"))  //     
        {
			DeleteAttribute(&RealShips[i], "");
		}
	}
}

int GetRealShipsCount()
{ //   
	int result = 0;

	for (int i= 0; i< REAL_SHIPS_QUANTITY; i++)
	{
		if (checkAttribute(&RealShips[i], "name"))
		{
			result++;
		}
	}

	return result;
}

//   
int FindFirstEmptyShip()
{
	for(int i = 0; i < REAL_SHIPS_QUANTITY; i++)
	{
		if(!checkAttribute(&RealShips[i], "name"))
		{
			return i;
		}
	}

	return -1;
}


/*
float SpeedByHullUpgrade(aref refCharacter)
{
	int iHull = sti(refCharacter.ship.upgrades.hull) - 1;

	float fResult = 1.0 - (0.05 * iHull);

	return fResult;
}


float SpeedBySailsUpgrade(aref refCharacter)
{
	int iSails = sti(refCharacter.ship.upgrades.sails) - 1;
	iSails = iSails * 5;
	float fResult = 1.0 + (0.01 * iSails);

	return fResult;
}
*/

float FindShipSpeed(aref refCharacter)
{
	if(!CheckAttribute(refCharacter, "Ship.type"))
	{
		trace("Character " + refCharacter.id + " have no ship!");
		return 0.0;
	}
	int nShipType = sti(refCharacter.ship.type);
	if(nShipType == SHIP_NOTUSED)
	{
		trace("Character " + refCharacter.id + " have invalid ship!");
		return 1.0;
	}
	ref rShip = GetRealShip(nShipType);
	
	float	fMaxSpeedZ = stf(rShip.SpeedRate);  //  
	float fShipHp = stf(refCharacter.ship.hp);
	float fShipMaxHp = stf(rShip.HP);
	float fSpeedFromHp = fShipHp/fShipMaxHp;
	fSpeedFromHp = 0.8 + fSpeedFromHp*0.3;

	if(fSpeedFromHp > 1.0) //     
	{
		fSpeedFromHp = 1.0;
	}

	float fSailsDamage = stf(refCharacter.ship.sp);

	float	fTRFromSailDamage = Bring2Range(0.1, 1.0, 0.1, 100.0, fSailsDamage); //0.3

	float fTRFromShipState = fSpeedFromHp * fTRFromSailDamage;
	
	float	fLoad = Clampf(stf(refCharacter.Ship.Cargo.Load) / stf(rShip.Capacity));
	float	fTRFromWeight = Clampf(1.03 - stf(rShip.SpeedDependWeight) * fLoad);
	float   fTRFromSkill = SpeedBySkill(refCharacter);
	//  
	float fCrewMax = stf(rShip.MaxCrew);
	float fCrewOpt = stf(rShip.OptCrew);
	float fCrewCur = stf(refCharacter.Ship.Crew.Quantity);
	if (fCrewCur > fCrewMax)
	{
		fCrewCur = fCrewMax;
	}
	float  fTRFromPeople;
	fTRFromPeople = 0.85 + ((GetCrewExp(refCharacter, "Sailors") * fCrewCur) / (fCrewOpt * GetCrewExpRate())) * 0.15;
	if (fTRFromPeople > 1) fTRFromPeople = 1;
	 
	fMaxSpeedZ = fMaxSpeedZ * fTRFromWeight * fTRFromSkill * fTRFromShipState * fTRFromPeople;

	return fMaxSpeedZ;
}

float SpeedBySkill(aref refCharacter)
{
	float fSkill = GetSummonSkillFromNameToOld(refCharacter, SKILL_SAILING);

	float fTRFromSkill = 0.7 + (0.03 *  fSkill);

	//float fSpeedByHullUpgrade = SpeedByHullUpgrade(refCharacter);
	//float fSpeedBySailsUpgrade = SpeedBySailsUpgrade(refCharacter);

	//fTRFromSKill = fTRFromSKill * fSpeedByHullUpgrade * fSpeedBySailsUpgrade;
    float fSpeedPerk = AIShip_isPerksUse(CheckOfficersPerk(refCharacter, "ShipSpeedUp"), 1.0, 1.15);   //slib
    fSpeedPerk = AIShip_isPerksUse(CheckOfficersPerk(refCharacter, "SailingProfessional"), fSpeedPerk, 1.20);
    
	return fTRFromSKill*fSpeedPerk;
}

float FindShipTurnRate(aref refCharacter)
{
	if(!CheckAttribute(refCharacter, "Ship.type"))
	{
		trace("Character " + refCharacter.id + " have no ship!");
		return 0.0;
	}
	int nShipType = sti(refCharacter.ship.type);
	if(nShipType == SHIP_NOTUSED)
	{
		trace("Character " + refCharacter.id + " have invalid ship!");
		return 1.0;
	}
	ref rShip = GetRealShip(nShipType);

	float fShipHp = stf(refCharacter.ship.hp);
	float fShipMaxHp = stf(rShip.HP);
	float fSpeedFromHp = fShipHp/fShipMaxHp;
	fSpeedFromHp = 0.7 + fSpeedFromHp * 0.3;

	float fLoad = Clampf(stf(refCharacter.Ship.Cargo.Load) / stf(rShip.Capacity));
	float fTRFromWeight;
	if (iArcadeSails == 1)
	{
		fTRFromWeight = Clampf(1.03 - stf(rShip.TurnDependWeight) * fLoad);
	}
	else
	{
		fTRFromWeight = Clampf(1.03 - 2.0*stf(rShip.TurnDependWeight) * fLoad); //   
	}
	//  ,  1 float fTRFromSpeed = 1.0 - stf(rShip.TurnDependSpeed);
	//  
	//float fCrewMin = stf(rShip.MinCrew);
	float fCrewMax = stf(rShip.MaxCrew);
	float fCrewOpt = stf(rShip.OptCrew);
	float fCrewCur = stf(refCharacter.Ship.Crew.Quantity);
	if (fCrewCur > fCrewMax)
	{
		fCrewCur = fCrewMax;
	}
	float  fTRFromPeople;
	if (iArcadeSails == 1)
	{
		fTRFromPeople = 0.3 + ((GetCrewExp(refCharacter, "Sailors") * fCrewCur) / (fCrewOpt * GetCrewExpRate())) * 0.7;
	}
	else
	{
		fTRFromPeople = 0.05 + ((GetCrewExp(refCharacter, "Sailors") * fCrewCur) / (fCrewOpt * GetCrewExpRate())) * 0.95;
	}
	if (fTRFromPeople > 1) fTRFromPeople = 1;
	
	float fTRFromSKill = TurnBySkill(refCharacter);

	float fTRFromSailDamage = Bring2Range(0.05, 1.0, 0.1, 100.0, stf(refCharacter.ship.sp));

	float fTurn = fTRFromWeight * fTRFromSkill * fTRFromPeople * fTRFromSailDamage * fSpeedFromHp;

	//Log_info(refCharacter.id + "  " + fTurn);
	return fTurn;	
}

float TurnBySkill(aref refCharacter)
{
	float fSkill = GetSummonSkillFromNameToOld(refCharacter, SKILL_SAILING);
	float fTRFromSKill;

    if (iArcadeSails == 1)
	{
		fTRFromSKill = 0.5 + (0.05 * fSkill);
	}
	else
	{
		fTRFromSKill = 0.3 + (0.07 * fSkill);
	}
	
    float fSpeedPerk = AIShip_isPerksUse(CheckOfficersPerk(refCharacter, "ShipTurnRateUp"), 1.0, 1.15);   //slib
    fSpeedPerk = AIShip_isPerksUse(CheckOfficersPerk(refCharacter, "SailingProfessional"), fSpeedPerk, 1.20);
    float fFastTurn180 = AIShip_isPerksUse(CheckOfficersPerk(refCharacter, "Turn180"), 1.0, 8.0);
    
	return fTRFromSKill*fSpeedPerk*fFastTurn180;
}

int GetCannonsNum(aref chr)
{
	int nShipType = sti(chr.ship.type);
    ref refBaseShip = GetRealShip(nShipType);

	int iCannons = GetBortIntactCannonsNum(chr, "cannonf", sti(refBaseShip.fcannon)) + GetBortIntactCannonsNum(chr, "cannonb", sti(refBaseShip.bcannon)) + GetBortIntactCannonsNum(chr, "cannonl", sti(refBaseShip.lcannon)) + GetBortIntactCannonsNum(chr, "cannonr", sti(refBaseShip.rcannon));

	return iCannons;
}

// boal
int GetBortCannonsQty(aref chr, string  sType)
{
	int nShipType = sti(chr.ship.type);
    ref refBaseShip = GetRealShip(nShipType);

	int iCannons = GetBortIntactCannonsNum(chr, sType, sti(refBaseShip.(sType)));

	return iCannons;
}

int GetBortCannonsMaxQty(aref chr, string  sType)
{
	int nShipType = sti(chr.ship.type);
    ref refBaseShip = GetRealShip(nShipType);

	int iCannons = sti(refBaseShip.(sType));

	return iCannons;
}

///////////////////////   //////////////////////
void SetShipyardStore(ref NPChar)
{
    int    iTest_ship, i;
	string attrName;
	
	if (CheckAttribute(NPChar, "shipyard")) return; //      
	
	SaveCurrentNpcQuestDateParam(npchar, "shipyardDate"); //   
    
    if (bBettaTestMode)
    {
        for (i = 1; i <=SHIP_TYPES_QUANTITY; i++)
        {
            attrName = "ship" + i;
            FillShipParamShipyard(NPChar, GenerateStoreShip(i-1), attrName);
        }
        
        return;
    }

//atpeace: edit to enable every ship in the game to be bought from the shipyard    
FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_TARTANE), "ship300");
FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_WAR_TARTANE), "ship301");
FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Gunboat), "ship302");
FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_BERMSLOOP), "ship303");
FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_EDINBURG), "ship304");
FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Cutter), "ship305");
FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_LuggerVML), "ship306");
FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_LUGGER), "ship307");
FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_PINK), "ship308");
FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_LUGGER_h), "ship309");
FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Galeoth_h), "ship310");
FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_SLOOP), "ship311");
FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Ketch), "ship312");
FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_YACHT), "ship313");
FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Sloop_Cutter1_18), "ship314");
FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_BOUNTY), "ship315");
FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_BARQUE), "ship316");
FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_COLONIALSCHOONER), "ship317");
FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_SHNYAVA), "ship318");
FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_SCHOONER), "ship319");
FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_XEBEC), "ship320");
FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_XEBEC_FRANCE), "ship321");
FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_BRIGANTINE), "ship322");
FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_BRIG), "ship323");
FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_BARKENTINE), "ship324");
FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_INTERCEPTOR), "ship325");
FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_FLEUT), "ship326");
FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_BATTLEXEBEC), "ship327");
FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Brig_20_Gun1_18), "ship328");
FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_PINNACE), "ship329");
FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_SOPHIE), "ship330");
FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_GALEON_L), "ship331");
FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_FLEUT2), "ship332");
FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Fleut4_50), "ship333");
FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_HMS_Bounty), "ship334");
FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Hooker1), "ship335");
FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_brig_n1), "ship336");
FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_USS_ENTERPRISE), "ship337");
FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Brig3), "ship338");
FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_PACKET_BRIG), "ship339");
FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_ENTERPRISE), "ship340");
FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_SLOOPOFWAR), "ship341");
FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_PINNACE3_50), "ship342");
FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_PINNACE2), "ship343");
FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_War_Pinnace), "ship344");
FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_CARAVEL), "ship345");
FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Corvette5), "ship346");
FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Caravel2), "ship347");
FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_XebecAS), "ship348");
FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Pinnace11), "ship349");
FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_BLACKANGEL), "ship350");
FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_BATTLECORVETTE), "ship351");
FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Batavia2), "ship352");
FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_CrimsonBlood), "ship353");
FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Batavia), "ship354");
FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_THEBLACKPEARL), "ship355");
FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_BLACKPEARL), "ship356");
FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_SURPRISE), "ship357");
FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_TwoDecker1_47), "ship358");
FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_CorvFrig2_50), "ship359");
FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_PO_Fleut50), "ship360");
FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Greyhound), "ship361");
FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_CORVETTE), "ship362");
FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_LYDIA), "ship363");
FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_JAMAICASHIP), "ship364");
FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_GALEON), "ship365");
FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_NIGHTMARE), "ship366");
FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_COLONIALFRIGATE), "ship367");
FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_BOUSSOLE), "ship368");
FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_LIGHTFRIGATE), "ship369");
FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Lineship47), "ship370");
FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Amsterdam), "ship371");
FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_GALEON_H), "ship372");
FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Endeavour), "ship373");
FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_FastGalleon1), "ship374");
FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_MERMAIDGRIEF), "ship375");
FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_BATTLEFRIGATE), "ship376");
FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_FEARLESS), "ship377");
FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_FRIGATE_SAT), "ship378");
FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_FRIGATE), "ship379");
FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Mordaunt), "ship380");
FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_SALAMANDER), "ship381");
FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_FleutOfWar34G), "ship382");
FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Galeon1), "ship383");
//Finish atpeace edit

    FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_TARTANE), "ship1");
    
	iTest_ship = rand(2);
	if (iTest_ship == 1)
	{
	if (iTest_ship == 1)FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_WAR_TARTANE), "ship2");
	if (iTest_ship == 2)FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Gunboat), "ship2");
	if (iTest_ship == 3) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_BERMSLOOP), "ship2");
	
	}
	if (iTest_ship == 2)
	{
	if (iTest_ship == 1) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_BERMSLOOP), "ship2");
	if (iTest_ship == 2) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Cutter), "ship2");
	if (iTest_ship == 3) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_LuggerVML), "ship2");
	if (iTest_ship == 4)FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_WAR_TARTANE), "ship2");
	if (iTest_ship == 5)FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Gunboat), "ship2");
	if (iTest_ship == 6) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_BERMSLOOP), "ship2");
	if (iTest_ship == 7) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_EDINBURG), "ship2");
	if (iTest_ship == 8) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Cutter), "ship2");
		
	}

	iTest_ship = rand(2);
	if (iTest_ship == 1) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_BERMSLOOP), "ship3");
	if (iTest_ship == 2) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Cutter), "ship3");
	if (iTest_ship == 3) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_LuggerVML), "ship3");
	if (iTest_ship == 4)FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_WAR_TARTANE), "ship3");
	if (iTest_ship == 5)FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Gunboat), "ship3");
	if (iTest_ship == 6) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_BERMSLOOP), "ship3");
	if (iTest_ship == 7) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_EDINBURG), "ship3");
	if (iTest_ship == 8) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Cutter), "ship3");
	if (iTest_ship == 9) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_LUGGER), "ship3");
	if (iTest_ship == 10) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_PINK), "ship3");
	if (iTest_ship == 11) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_LUGGER_h), "ship3");
	if (iTest_ship == 12) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Galeoth_h), "ship3");
	if (iTest_ship == 13) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Ketch), "ship3");
	if (iTest_ship == 14) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_YACHT), "ship3");
	if (iTest_ship == 15) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_BOUNTY), "ship3");
	if (iTest_ship == 16) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_HMS_Bounty), "ship3");	
	

	iTest_ship = rand(3);
	if (iTest_ship == 1) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_LUGGER), "ship4");
		if (iTest_ship == 2) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_PINK), "ship4");
		if (iTest_ship == 3) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_LUGGER_h), "ship4");
		if (iTest_ship == 4) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Galeoth_h), "ship4");
		if (iTest_ship == 5) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Ketch), "ship4");
		if (iTest_ship == 6) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_YACHT), "ship4");
		if (iTest_ship == 7) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_BOUNTY), "ship4");
		if (iTest_ship == 8) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_HMS_Bounty), "ship4");
	
	

    if (sti(PChar.rank) > 1)
    {
		iTest_ship = rand(4);
		if (iTest_ship == 1) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_LUGGER), "ship5");
		if (iTest_ship == 2) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_PINK), "ship5");
		if (iTest_ship == 3) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_LUGGER_h), "ship5");
		if (iTest_ship == 4) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Galeoth_h), "ship5");
		if (iTest_ship == 5) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Ketch), "ship5");
		if (iTest_ship == 6) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_YACHT), "ship5");
		if (iTest_ship == 7) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_BOUNTY), "ship5");
		if (iTest_ship == 8) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_HMS_Bounty), "ship5");
		if (iTest_ship == 9) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_SLOOP), "ship5");
		if (iTest_ship == 10) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Sloop_Cutter1_18), "ship5");
		if (iTest_ship == 11) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_XEBEC), "ship5");
		if (iTest_ship == 12) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_BARQUE), "ship5");
		if (iTest_ship == 13) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_SHNYAVA), "ship5");
		if (iTest_ship == 14) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_XEBEC_FRANCE), "ship5");
		if (iTest_ship == 15) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Brig_20_Gun1_18), "ship5");
		if (iTest_ship == 16) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Hooker1), "ship5");
		
		

		iTest_ship = rand(4);
		if (iTest_ship == 1) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_SLOOP), "ship6");
		if (iTest_ship == 2) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Sloop_Cutter1_18), "ship6");
		if (iTest_ship == 3) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_XEBEC), "ship6");
		if (iTest_ship == 4) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_BARQUE), "ship6");
		if (iTest_ship == 5) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_SHNYAVA), "ship6");
		if (iTest_ship == 6) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_XEBEC_FRANCE), "ship6");
		if (iTest_ship == 7) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Brig_20_Gun1_18), "ship6");
		if (iTest_ship == 8) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Hooker1), "ship6");
		
		
	}
	if (sti(PChar.rank) > 3)
    {
		iTest_ship = rand(6);
		if (iTest_ship == 1) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_SLOOP), "ship8");
		if (iTest_ship == 2) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Sloop_Cutter1_18), "ship8");
		if (iTest_ship == 3) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_XEBEC), "ship8");
		if (iTest_ship == 4) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_BARQUE), "ship8");
		if (iTest_ship == 5) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_SHNYAVA), "ship8");
		if (iTest_ship == 6) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_XEBEC_FRANCE), "ship8");
		if (iTest_ship == 7) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Brig_20_Gun1_18), "ship8");
		if (iTest_ship == 8) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Hooker1), "ship8");
		
		

		iTest_ship = rand(6);
		if (iTest_ship == 1) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_SLOOP), "ship9");
		if (iTest_ship == 2) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Sloop_Cutter1_18), "ship9");
		if (iTest_ship == 3) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_XEBEC), "ship9");
		if (iTest_ship == 4) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_BARQUE), "ship9");
		if (iTest_ship == 5) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_SHNYAVA), "ship9");
		if (iTest_ship == 6) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_XEBEC_FRANCE), "ship9");
		if (iTest_ship == 7) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Brig_20_Gun1_18), "ship9");
		if (iTest_ship == 8) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Hooker1), "ship9");
		if (iTest_ship == 9) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_COLONIALSCHOONER), "ship9");
		if (iTest_ship == 10) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_SCHOONER), "ship9");
		if (iTest_ship == 11) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_BRIGANTINE), "ship9");
		if (iTest_ship == 12) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_BRIG), "ship9");
		if (iTest_ship == 13) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_BARKENTINE), "ship9");
		if (iTest_ship == 14) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_INTERCEPTOR), "ship9");
		if (iTest_ship == 15) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_BATTLEXEBEC), "ship9");
		if (iTest_ship == 16) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_PINNACE), "ship9");
		if (iTest_ship == 17) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_brig_n1), "ship9");
		if (iTest_ship == 18) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_SOPHIE), "ship9");
		if (iTest_ship == 19) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_USS_ENTERPRISE), "ship9");
		if (iTest_ship == 20) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Brig3), "ship9");
		if (iTest_ship == 21) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_PACKET_BRIG), "ship9");
		if (iTest_ship == 22) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_ENTERPRISE), "ship9");
		if (iTest_ship == 23) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_SLOOPOFWAR), "ship9");
		if (iTest_ship == 24) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_FLEUT), "ship9");
		if (iTest_ship == 25) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_CARAVEL), "ship9");
		if (iTest_ship == 26) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_XebecAS), "ship9");
		
	
	
		iTest_ship = rand(6);
		if (iTest_ship == 1) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_COLONIALSCHOONER), "ship10");
		if (iTest_ship == 2) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_SCHOONER), "ship10");
		if (iTest_ship == 3) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_BRIGANTINE), "ship10");
		if (iTest_ship == 4) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_BRIG), "ship10");
		if (iTest_ship == 5) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_BARKENTINE), "ship10");
		if (iTest_ship == 6) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_INTERCEPTOR), "ship10");
		if (iTest_ship == 7) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_BATTLEXEBEC), "ship10");
		if (iTest_ship == 8) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_PINNACE), "ship10");
		if (iTest_ship == 9) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_brig_n1), "ship10");
		if (iTest_ship == 10) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_SOPHIE), "ship10");
		if (iTest_ship == 11) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_USS_ENTERPRISE), "ship10");
		if (iTest_ship == 12) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Brig3), "ship10");
		if (iTest_ship == 13) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_PACKET_BRIG), "ship10");
		if (iTest_ship == 14) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_ENTERPRISE), "ship10");
		if (iTest_ship == 15) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_SLOOPOFWAR), "ship10");
		if (iTest_ship == 16) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_FLEUT), "ship10");
		if (iTest_ship == 17) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_CARAVEL), "ship10");
		if (iTest_ship == 18) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_XebecAS), "ship10");
		if (iTest_ship == 19) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Caravel2), "ship10");
		if (iTest_ship == 20) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Fleut4_50), "ship10");
		if (iTest_ship == 21) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_FLEUT2), "ship10");
		if (iTest_ship == 22) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_GALEON_L), "ship10");
		
	}
	if (sti(PChar.rank) > 5)
    {
		iTest_ship = rand(8);
		if (iTest_ship == 1) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_COLONIALSCHOONER), "ship11");
		if (iTest_ship == 2) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_SCHOONER), "ship11");
		if (iTest_ship == 3) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_BRIGANTINE), "ship11");
		if (iTest_ship == 4) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_BRIG), "ship11");
		if (iTest_ship == 5) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_BARKENTINE), "ship11");
		if (iTest_ship == 6) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_INTERCEPTOR), "ship11");
		if (iTest_ship == 7) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_BATTLEXEBEC), "ship11");
		if (iTest_ship == 8) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_PINNACE), "ship11");
		if (iTest_ship == 9) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_brig_n1), "ship11");
		if (iTest_ship == 10) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_SOPHIE), "ship11");
		if (iTest_ship == 11) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_USS_ENTERPRISE), "ship11");
		if (iTest_ship == 12) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Brig3), "ship11");
		if (iTest_ship == 13) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_PACKET_BRIG), "ship11");
		if (iTest_ship == 14) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_ENTERPRISE), "ship11");
		if (iTest_ship == 15) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_SLOOPOFWAR), "ship11");
		if (iTest_ship == 16) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_FLEUT), "ship11");
		if (iTest_ship == 17) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_CARAVEL), "ship11");
		if (iTest_ship == 18) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_XebecAS), "ship11");
		if (iTest_ship == 19) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Caravel2), "ship11");
		if (iTest_ship == 20) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Fleut4_50), "ship11");
		if (iTest_ship == 21) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_FLEUT2), "ship11");
		if (iTest_ship == 22) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_GALEON_L), "ship11");
		if (iTest_ship == 23) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_PINNACE3_50), "ship11");
		if (iTest_ship == 24) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_PINNACE2), "ship11");
		if (iTest_ship == 25) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_War_Pinnace), "ship11");
		if (iTest_ship == 26) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Pinnace11), "ship11");
		
	
		iTest_ship = rand(8);
		if (iTest_ship == 1) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_COLONIALSCHOONER), "ship12");
		if (iTest_ship == 2) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_SCHOONER), "ship12");
		if (iTest_ship == 3) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_BRIGANTINE), "ship12");
		if (iTest_ship == 4) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_BRIG), "ship12");
		if (iTest_ship == 5) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_BARKENTINE), "ship12");
		if (iTest_ship == 6) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_INTERCEPTOR), "ship12");
		if (iTest_ship == 7) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_BATTLEXEBEC), "ship12");
		if (iTest_ship == 8) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_PINNACE), "ship12");
		if (iTest_ship == 9) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_brig_n1), "ship12");
		if (iTest_ship == 10) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_SOPHIE), "ship12");
		if (iTest_ship == 11) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_USS_ENTERPRISE), "ship12");
		if (iTest_ship == 12) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Brig3), "ship12");
		if (iTest_ship == 13) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_PACKET_BRIG), "ship12");
		if (iTest_ship == 14) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_ENTERPRISE), "ship12");
		if (iTest_ship == 15) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_SLOOPOFWAR), "ship12");
		if (iTest_ship == 16) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_FLEUT), "ship12");
		if (iTest_ship == 17) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_CARAVEL), "ship12");
		if (iTest_ship == 18) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_XebecAS), "ship12");
		if (iTest_ship == 19) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Caravel2), "ship12");
		if (iTest_ship == 20) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Fleut4_50), "ship12");
		if (iTest_ship == 21) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_FLEUT2), "ship12");
		if (iTest_ship == 22) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_GALEON_L), "ship12");
		if (iTest_ship == 23) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_PINNACE3_50), "ship12");
		if (iTest_ship == 24) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_PINNACE2), "ship12");
		if (iTest_ship == 25) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_War_Pinnace), "ship12");
		if (iTest_ship == 26) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Pinnace11), "ship12");
		
	
	
		iTest_ship = rand(8);
		if (iTest_ship == 1) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_FLEUT), "ship13");
		if (iTest_ship == 2) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_CARAVEL), "ship13");
		if (iTest_ship == 3) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_XebecAS), "ship13");
		if (iTest_ship == 4) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Caravel2), "ship13");
		if (iTest_ship == 5) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Fleut4_50), "ship13");
		if (iTest_ship == 6) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_FLEUT2), "ship13");
		if (iTest_ship == 7) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_GALEON_L), "ship13");
		if (iTest_ship == 8) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_PINNACE3_50), "ship13");
		if (iTest_ship == 9) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_PINNACE2), "ship13");
		if (iTest_ship == 10) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_War_Pinnace), "ship13");
		if (iTest_ship == 11) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Pinnace11), "ship13");
		if (iTest_ship == 12) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_TwoDecker1_47), "ship13");
		if (iTest_ship == 13) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_PO_Fleut50), "ship13");
		if (iTest_ship == 14) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Greyhound), "ship13");
		if (iTest_ship == 15) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_GALEON), "ship13");
		if (iTest_ship == 16) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_FastGalleon1), "ship13");
		if (iTest_ship == 17) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_FleutOfWar34G), "ship13");
		if (iTest_ship == 18) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Greyhound), "ship13");
		if (iTest_ship == 19) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_GALEON), "ship13");
		
	
    }
    if (sti(PChar.rank) > 8)
    {
		iTest_ship = rand(50);
		if (iTest_ship == 1) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_FLEUT), "ship14");
		if (iTest_ship == 2) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_CARAVEL), "ship14");
		if (iTest_ship == 3) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_XebecAS), "ship14");
		if (iTest_ship == 4) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Caravel2), "ship14");
		if (iTest_ship == 5) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Fleut4_50), "ship14");
		if (iTest_ship == 6) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_FLEUT2), "ship14");
		if (iTest_ship == 7) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_GALEON_L), "ship14");
		if (iTest_ship == 8) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_PINNACE3_50), "ship14");
		if (iTest_ship == 9) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_PINNACE2), "ship14");
		if (iTest_ship == 10) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_War_Pinnace), "ship14");
		if (iTest_ship == 11) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Pinnace11), "ship14");
		if (iTest_ship == 12) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_TwoDecker1_47), "ship14");
		if (iTest_ship == 13) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_PO_Fleut50), "ship14");
		if (iTest_ship == 14) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Greyhound), "ship14");
		if (iTest_ship == 15) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_GALEON), "ship14");
		if (iTest_ship == 16) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_FastGalleon1), "ship14");
		if (iTest_ship == 17) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_FleutOfWar34G), "ship14");
		if (iTest_ship == 18) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Greyhound), "ship14");
		if (iTest_ship == 19) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_GALEON), "ship14");
		
		
	
		iTest_ship = rand(70);
		if (iTest_ship == 1) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_FLEUT), "ship15");
		if (iTest_ship == 2) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_CARAVEL), "ship15");
		if (iTest_ship == 3) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_XebecAS), "ship15");
		if (iTest_ship == 4) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Caravel2), "ship15");
		if (iTest_ship == 5) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Fleut4_50), "ship15");
		if (iTest_ship == 6) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_FLEUT2), "ship15");
		if (iTest_ship == 7) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_GALEON_L), "ship15");
		if (iTest_ship == 8) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_PINNACE3_50), "ship15");
		if (iTest_ship == 9) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_PINNACE2), "ship15");
		if (iTest_ship == 10) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_War_Pinnace), "ship15");
		if (iTest_ship == 11) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Pinnace11), "ship15");
		if (iTest_ship == 12) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_TwoDecker1_47), "ship15");
		if (iTest_ship == 13) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_PO_Fleut50), "ship15");
		if (iTest_ship == 14) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Greyhound), "ship15");
		if (iTest_ship == 15) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_GALEON), "ship15");
		if (iTest_ship == 16) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_FastGalleon1), "ship15");
		if (iTest_ship == 17) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_FleutOfWar34G), "ship15");
		if (iTest_ship == 18) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Greyhound), "ship15");
		if (iTest_ship == 19) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_GALEON), "ship15");
		
    }
    
    if (sti(PChar.rank) > 12)
    {
		iTest_ship = rand(50);
		if (iTest_ship == 1) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_FLEUT), "ship141");
		if (iTest_ship == 2) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_CARAVEL), "ship141");
		if (iTest_ship == 3) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_XebecAS), "ship141");
		if (iTest_ship == 4) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Caravel2), "ship141");
		if (iTest_ship == 5) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Fleut4_50), "ship141");
		if (iTest_ship == 6) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_FLEUT2), "ship141");
		if (iTest_ship == 7) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_GALEON_L), "ship141");
		if (iTest_ship == 8) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_PINNACE3_50), "ship141");
		if (iTest_ship == 9) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_PINNACE2), "ship141");
		if (iTest_ship == 10) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_War_Pinnace), "ship141");
		if (iTest_ship == 11) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Pinnace11), "ship141");
		if (iTest_ship == 12) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_TwoDecker1_47), "ship141");
		if (iTest_ship == 13) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_PO_Fleut50), "ship141");
		if (iTest_ship == 14) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Greyhound), "ship141");
		if (iTest_ship == 15) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_GALEON), "ship141");
		if (iTest_ship == 16) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_FastGalleon1), "ship141");
		if (iTest_ship == 17) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_FleutOfWar34G), "ship141");
		if (iTest_ship == 18) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Greyhound), "ship141");
		if (iTest_ship == 19) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_GALEON), "ship141");
		
		

		iTest_ship = rand(70);				
		if (iTest_ship == 1) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_FLEUT), "ship151");
		if (iTest_ship == 2) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_CARAVEL), "ship151");
		if (iTest_ship == 3) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_XebecAS), "ship151");
		if (iTest_ship == 4) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Caravel2), "ship151");
		if (iTest_ship == 5) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Fleut4_50), "ship151");
		if (iTest_ship == 6) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_FLEUT2), "ship151");
		if (iTest_ship == 7) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_GALEON_L), "ship151");
		if (iTest_ship == 8) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_PINNACE3_50), "ship151");
		if (iTest_ship == 9) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_PINNACE2), "ship151");
		if (iTest_ship == 10) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_War_Pinnace), "ship151");
		if (iTest_ship == 11) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Pinnace11), "ship151");
		if (iTest_ship == 12) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_TwoDecker1_47), "ship151");
		if (iTest_ship == 13) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_PO_Fleut50), "ship151");
		if (iTest_ship == 14) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Greyhound), "ship151");
		if (iTest_ship == 15) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_GALEON), "ship151");
		if (iTest_ship == 16) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_FastGalleon1), "ship151");
		if (iTest_ship == 17) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_FleutOfWar34G), "ship151");
		if (iTest_ship == 18) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Greyhound), "ship151");
		if (iTest_ship == 19) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_GALEON), "ship151");
		if (iTest_ship == 20) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Galeon1), "ship151");
		if (iTest_ship == 21) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_INDIAMAN), "ship151");
		if (iTest_ship == 22) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_WarGalleon2), "ship151");
		if (iTest_ship == 23) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_sevenprovincien), "ship151");
		if (iTest_ship == 24) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_THEBLACKPEARL), "ship151");
		if (iTest_ship == 25) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_CrimsonBlood), "ship151");
		if (iTest_ship == 26) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Batavia2), "ship151");
		if (iTest_ship == 27) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Amsterdam), "ship151");
		if (iTest_ship == 28) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_GALEON_H), "ship151");
		
		
    }
    
    if (sti(PChar.rank) > 18)
    {
       		iTest_ship = rand(120);
	   	if (iTest_ship == 1) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_FLEUT), "ship16");
		if (iTest_ship == 2) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_CARAVEL), "ship16");
		if (iTest_ship == 3) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_XebecAS), "ship16");
		if (iTest_ship == 4) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Caravel2), "ship16");
		if (iTest_ship == 5) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Fleut4_50), "ship16");
		if (iTest_ship == 6) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_FLEUT2), "ship16");
		if (iTest_ship == 7) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_GALEON_L), "ship16");
		if (iTest_ship == 8) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_PINNACE3_50), "ship16");
		if (iTest_ship == 9) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_PINNACE2), "ship16");
		if (iTest_ship == 10) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_War_Pinnace), "ship16");
		if (iTest_ship == 11) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Pinnace11), "ship16");
		if (iTest_ship == 12) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_TwoDecker1_47), "ship16");
		if (iTest_ship == 13) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_PO_Fleut50), "ship16");
		if (iTest_ship == 14) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Greyhound), "ship16");
		if (iTest_ship == 15) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_GALEON), "ship16");
		if (iTest_ship == 16) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_FastGalleon1), "ship16");
		if (iTest_ship == 17) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_FleutOfWar34G), "ship16");
		if (iTest_ship == 18) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Greyhound), "ship16");
		if (iTest_ship == 19) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_GALEON), "ship16");
		if (iTest_ship == 20) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Galeon1), "ship16");
		if (iTest_ship == 21) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_INDIAMAN), "ship16");
		if (iTest_ship == 22) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_WarGalleon2), "ship16");
		if (iTest_ship == 23) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_sevenprovincien), "ship16");
		if (iTest_ship == 24) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_THEBLACKPEARL), "ship16");
		if (iTest_ship == 25) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_CrimsonBlood), "ship16");
		if (iTest_ship == 26) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Batavia2), "ship16");
		if (iTest_ship == 27) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Amsterdam), "ship16");
		if (iTest_ship == 28) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_GALEON_H), "ship16");
		
       	
		


	   	iTest_ship = rand(120);
	   	if (iTest_ship == 1) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_FLEUT), "ship17");
		if (iTest_ship == 2) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_CARAVEL), "ship17");
		if (iTest_ship == 3) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_XebecAS), "ship17");
		if (iTest_ship == 4) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Caravel2), "ship17");
		if (iTest_ship == 5) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Fleut4_50), "ship17");
		if (iTest_ship == 6) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_FLEUT2), "ship17");
		if (iTest_ship == 7) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_GALEON_L), "ship17");
		if (iTest_ship == 8) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_PINNACE3_50), "ship17");
		if (iTest_ship == 9) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_PINNACE2), "ship17");
		if (iTest_ship == 10) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_War_Pinnace), "ship17");
		if (iTest_ship == 11) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Pinnace11), "ship17");
		if (iTest_ship == 12) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_TwoDecker1_47), "ship17");
		if (iTest_ship == 13) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_PO_Fleut50), "ship17");
		if (iTest_ship == 14) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Greyhound), "ship17");
		if (iTest_ship == 15) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_GALEON), "ship17");
		if (iTest_ship == 16) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_FastGalleon1), "ship17");
		if (iTest_ship == 17) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_FleutOfWar34G), "ship17");
		if (iTest_ship == 18) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Greyhound), "ship17");
		if (iTest_ship == 19) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_GALEON), "ship17");
		if (iTest_ship == 20) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Galeon1), "ship17");
		if (iTest_ship == 21) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_INDIAMAN), "ship17");
		if (iTest_ship == 22) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_WarGalleon2), "ship17");
		if (iTest_ship == 23) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_sevenprovincien), "ship17");
		if (iTest_ship == 24) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_THEBLACKPEARL), "ship17");
		if (iTest_ship == 25) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_CrimsonBlood), "ship17");
		if (iTest_ship == 26) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Batavia2), "ship17");
		if (iTest_ship == 27) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_Amsterdam), "ship17");
		if (iTest_ship == 28) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_GALEON_H), "ship17");
		if (iTest_ship == 28) FillShipParamShipyard(NPChar, GenerateStoreShip(SHIP_ARABELLA), "ship17");
		
	
    }
}

void FreeShipFromShipyard(ref NPChar)
{
	if (GetNpcQuestPastDayParam(NPChar, "shipyardDate") > (3 + rand(6)))
	{
        aref   arDest, arImt;
		string sAttr;
		int    iNum, i, iShip;
		makearef(arDest, NPChar.shipyard);
		iNum = GetAttributesNum(arDest);
		for (i = 0; i < iNum; i++)
		{
	    	arImt = GetAttributeN(arDest, i);
	    	iShip = sti(arImt.Type); //GetAttributeValue(arImt));
	    	DeleteAttribute(&RealShips[iShip], "StoreShip"); //  
	    }
        DeleteAttribute(NPChar, "shipyard");
	}
}

void FillShipParamShipyard(ref NPChar, int _iType, string _sShipNum)
{
    aref    arTo, arFrom;
    
	DeleteAttribute(NPChar, "ship");
    NPChar.Ship.Type = _iType;
    
	SetRandomNameToShip(NPChar);

    SetBaseShipData(NPChar);
    SetCrewQuantity(NPChar, 0);
    if (sti(NPChar.Ship.Cannons.Type) != CANNON_TYPE_NONECANNON)
    {
    	NPChar.Ship.Cannons.Type = CANNON_TYPE_CANNON_LBS4; // to_do      
    }
    DeleteAttribute(NPChar, "Ship.Cargo");  // 
    SetGoodsInitNull(NPChar);
    RecalculateCargoLoad(NPChar);
    
    FillShipyardShipBack(NPChar, _sShipNum);
}

void FillShipyardShip(ref NPChar, string _sShipNum)
{
    aref    arTo, arFrom;

	DeleteAttribute(NPChar, "ship");

    makearef(arFrom,   NPChar.shipyard.(_sShipNum));
    NPChar.Ship = "";
	makearef(arTo, NPChar.Ship);
	CopyAttributes(arTo, arFrom);
}

void FillShipyardShipBack(ref NPChar, string _sShipNum)
{
    aref    arTo, arFrom;

  	DeleteAttribute(NPChar, "shipyard." + _sShipNum);
    NPChar.shipyard.(_sShipNum) = "";
    makearef(arTo,   NPChar.shipyard.(_sShipNum));
	makearef(arFrom, NPChar.Ship);
	CopyAttributes(arTo, arFrom);
}

//    
string GetShip_deck(ref chr, bool map2sea)
{
	string ret, add;
	int    iType = sti(chr.Ship.Type);
	if (map2sea)
	{
	    ret = "Ship_deck_";
	}
	else
	{
	    ret = "Deck_Near_Ship_";
	}
	add = "Low"; //   
	if (iType != SHIP_NOTUSED)
	{
        ref rRealShip = GetRealShip(iType);
        
		add = rRealShip.DeckType;
	}
	
	return ret + add;
}

void MakeCloneShipDeck(ref chr, bool map2sea)
{
	ref rOrg, rClone;
	int iOrg, iClone;
    string locId, toLocId;
    
    locId = GetShip_deck(chr, map2sea);
    if (map2sea)
	{
	    toLocId = "Ship_deck";
	}
	else
	{
	    toLocId = "Deck_Near_Ship";
	}
	
	iOrg = FindLocation(locId);
	iClone = FindLocation(toLocId);

	makeref(rOrg, Locations[iOrg]);
	makeref(rClone, Locations[iClone]);

	DeleteAttribute(rClone, "");
	CopyAttributes(rClone, rOrg);
	rClone.id = toLocId;
	rClone.index = iClone;
}

void MakeCloneFortBoarding(string fromLocId)
{
	ref rOrg, rClone;
	int iOrg, iClone;
    string toLocId;
    
    toLocId = "BOARDING_FORT";

	iOrg = FindLocation(fromLocId);
	iClone = FindLocation(toLocId);

	makeref(rOrg, Locations[iOrg]);
	makeref(rClone, Locations[iClone]);

	DeleteAttribute(rClone, "");
	CopyAttributes(rClone, rOrg);
	rClone.id = toLocId;
	rClone.index = iClone;
	
    rClone.type = "fort_attack";
	LAi_LocationFantomsGen(rClone, false);
	DeleteAttribute(rClone, "reload");
	//    .   goto, soldiers  .  rld  .
	if (rClone.models.always.locators == "fortV_locators") 
	{
		rClone.models.always.locators = "fortV_lAttack";
		rClone.models.always.fortV = "fortV_attack";	
	}
	else
	{
		rClone.models.always.locators = "fortVRight_lAttack";
		rClone.models.always.fortV = "fortVRight_attack";
	}
	rClone.boarding.locatorNum = 15;
	rClone.boarding = "false";
	rClone.boarding.nextdeck = "";
	rClone.image = "loading\Fort_512.tga";
}